import { IActionOptions, IGetterOptions, IMutationOptions, IStateOptions } from './annotations';
export declare type getterMiddlewareType = (options: IGetterOptions | undefined, target: any, propertyKey: string, descriptor: PropertyDescriptor) => any;
export declare type stateMiddlewareType = (options: IStateOptions | undefined, target: any, propertyKey: string) => any;
export declare type mutationMiddlewareType = (options: IMutationOptions | undefined, target: any, propertyKey: string, descriptor: PropertyDescriptor) => any;
export declare type actionMiddlewareType = (options: IActionOptions | undefined, target: any, propertyKey: string, descriptor: PropertyDescriptor) => any;
export declare var getterMiddlewares: getterMiddlewareType[];
export declare var stateMiddlewares: stateMiddlewareType[];
export declare var mutationMiddlewares: mutationMiddlewareType[];
export declare var actionMiddlewares: actionMiddlewareType[];
export declare function addGetterMiddleware(...middlewares: getterMiddlewareType[]): void;
export declare function addStateMiddleware(...middlewares: stateMiddlewareType[]): void;
export declare function addMutationMiddleware(...middlewares: Array<mutationMiddlewareType>): void;
export declare function addActionMiddleware(...middlewares: actionMiddlewareType[]): void;
